import Config from './config';
import ChangeWaiter from './change-waiter';
import SelfState from './self-state';
import EtcResponse from './etc-response';
import EtcValue from './etc-value';
import EtcValueNode from './etc-value-node';
export declare class EtcdPromise {
    private obs;
    static create(cfg: Config): EtcdPromise;
    constructor(cfg: Config);
    connect(): Promise<SelfState>;
    clusterState(): Promise<SelfState[]>;
    selfStat(url: string): Promise<SelfState>;
    update(key: string, ttl: number): Promise<EtcResponse>;
    addQueue(key: string, val: string, ttl: number): Promise<EtcResponse>;
    mkdir(key: string): Promise<EtcResponse>;
    rmdir(key: string, params?: any): Promise<EtcResponse>;
    delete(key: string): Promise<EtcResponse>;
    list(key: string, params?: any): Promise<EtcValue<EtcValueNode[]>>;
    getRaw(key: string, params?: any, options?: any): Promise<EtcResponse>;
    getString(key: string, params?: any): Promise<EtcValue<string>>;
    getJson(key: string, params?: any): Promise<EtcValue<any>>;
    setRaw(key: string, val: string): Promise<EtcResponse>;
    setJson(key: string, val: any): Promise<EtcResponse>;
    createChangeWaiter(path: string, params?: any, options?: any): ChangeWaiter;
}
export default EtcdPromise;
