"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const etcd_observable_1 = require("./etcd-observable");
class EtcdPromise {
    static create(cfg) {
        return new EtcdPromise(cfg);
    }
    constructor(cfg) {
        this.obs = new etcd_observable_1.default(cfg);
    }
    connect() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.connect().toPromise();
        });
    }
    clusterState() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.clusterState().toPromise();
        });
    }
    selfStat(url) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.selfStat(url).toPromise();
        });
    }
    update(key, ttl) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.update(key, ttl).toPromise();
        });
    }
    addQueue(key, val, ttl) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.addQueue(key, val, ttl).toPromise();
        });
    }
    mkdir(key) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.mkdir(key).toPromise();
        });
    }
    rmdir(key, params = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.rmdir(key, params).toPromise();
        });
    }
    delete(key) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.delete(key).toPromise();
        });
    }
    list(key, params = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.list(key, params).toPromise();
        });
    }
    getRaw(key, params = {}, options = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.getRaw(key, params, options).toPromise();
        });
    }
    getString(key, params = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.getString(key, params).toPromise();
        });
    }
    getJson(key, params = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.getJson(key, params).toPromise();
        });
    }
    setRaw(key, val) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.setRaw(key, val).toPromise();
        });
    }
    setJson(key, val) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.obs.setJson(key, val).toPromise();
        });
    }
    createChangeWaiter(path, params = {}, options = {}) {
        return this.obs.createChangeWaiter(path, params, options);
    }
}
exports.EtcdPromise = EtcdPromise;
exports.default = EtcdPromise;
//# sourceMappingURL=etcd-promise.js.map