"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const leader_info_1 = require("./leader-info");
class SelfState {
    constructor() {
        this.err = null;
    }
    static error(url, err) {
        let ret = new SelfState();
        ret.url = url;
        ret.err = err;
        return ret;
    }
    static ok(url, val) {
        let ret = new SelfState();
        ret.url = url;
        let json = JSON.parse(val);
        ret.name = json['name'];
        ret.id = json['id'];
        ret.state = json['state'];
        ret.startTime = new Date(json['startTime']);
        ret.leaderInfo = leader_info_1.default.fill(json['leaderInfo']);
        ret.recvAppendRequestCnt = json['recvAppendRequestCnt'];
        ret.sendAppendRequestCnt = json['sendAppendRequestCnt'];
        return ret;
    }
    isOk() {
        return this.err == null && this.id.length != 0;
    }
}
exports.SelfState = SelfState;
exports.default = SelfState;
//# sourceMappingURL=self-state.js.map